# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/org/jboss/ejb3/jboss-ejb3-transactions/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define namedversion %{version}

Name:           jboss-ejb3-transactions
Version:        1.0.2
Release:        1.4%{?dist}
Epoch:          0
Summary:        JBoss EJB3 Transactions
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn export http://anonsvn.jboss.org/repos/jbossas/projects/ejb3/tags/jboss-ejb3-transactions-1.0.2/
# Exported revision 94789.
# tar czf jboss-ejb3-transactions-1.0.2.tar.gz jboss-ejb3-transactions-1.0.2
Source0:        jboss-ejb3-transactions-1.0.2.tar.gz
Source1:        jboss-ejb3-transactions-jpp-depmap.xml
Source2:        jboss-ejb3-transactions-settings.xml
Source3:        jboss-ejb3-transactions-component-info.xml
Patch0:		%{name}-pom.patch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
Requires:       java >= 0:1.5.0
Requires:       concurrent
Requires:       jboss-aop2
Requires:       jboss-ejb-3.0-api
Requires:       jboss-ejb3-build
Requires:       jboss-ejb3-cache
Requires:       jboss-ejb3-ext-api-impl
Requires:       jboss-ejb3-interceptors
Requires:       jboss-common-logging-spi
Requires:       jboss-integration
Requires:       jboss-metadata
Requires:       jboss-parent
Requires:       jboss-transaction-1.0.1-api
Requires:       jboss-transaction-aspects
Requires:       jbossws
Requires:       jbossts
Requires:       dtdparser
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-rar
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-jboss-deploy-plugin
BuildRequires:  maven-release
BuildRequires:  maven-enforcer-rule-api
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  junit4
BuildRequires:  concurrent
BuildRequires:  jboss-aop2
BuildRequires:  jboss-ejb-3.0-api
BuildRequires:  jboss-ejb3-build
BuildRequires:  jboss-ejb3-cache
BuildRequires:  jboss-ejb3-ext-api-impl
BuildRequires:  jboss-ejb3-interceptors
BuildRequires:  jboss-common-logging-spi
BuildRequires:  jboss-integration
BuildRequires:  jboss-metadata
BuildRequires:  jboss-parent
BuildRequires:  jboss-transaction-1.0.1-api
BuildRequires:  jboss-transaction-aspects
BuildRequires:  jboss-test
BuildRequires:  jbossws
BuildRequires:  jbossts
BuildRequires:  dtdparser
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss EJB transactions.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q 
%patch0 -p1
%{_bindir}/find . -name "*.jar" | %{_bindir}/xargs -t %{__rm} -f

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository

%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        install javadoc:javadoc

%install
rm -rf %{buildroot}

# jars
install -d -m 755 %{buildroot}%{_javadir}
install -p -m 644 target/jboss-ejb3-transactions.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
install -p -m 644 target/jboss-ejb3-transactions-sources.jar %{buildroot}%{_javadir}/%{name}-%{version}-sources.jar
jar -cf $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-javadoc.jar -C target/site/apidocs/ .

(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
install -p -m 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.jboss.ejb3 jboss-ejb3-transactions %{namedversion} JPP %{name}

# javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
install -d -m 755 %{buildroot}%{repodir}
install -d -m 755 %{buildroot}%{repodirlib}
install -p -m 644 %{SOURCE3} %{buildroot}%{repodir}/component-info.xml
sed -i 's/@VERSION@/%{namedversion}-brew/g' %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
install -d -m 755 %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE1} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE2} %{buildroot}%{repodirsrc}
cp -p %{buildroot}%{_javadir}/%{name}-%{version}.jar %{buildroot}%{repodirlib}/jboss-ejb3-transactions.jar
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom %{buildroot}%{repodirlib}/jboss-ejb3-transactions.pom
cp -p %{buildroot}%{_javadir}/%{name}-%{version}-javadoc.jar %{buildroot}%{repodirlib}/jboss-ejb3-transactions-javadoc.jar
cp -p %{buildroot}%{_javadir}/%{name}-%{version}-sources.jar %{buildroot}%{repodirlib}/jboss-ejb3-transactions-sources.jar
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}-javadoc.jar
%{_javadir}/%{name}-javadoc.jar
%{_javadir}/%{name}-%{version}-sources.jar
%{_javadir}/%{name}-sources.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}/repository.jboss.com
%endif

%changelog
* Wed Aug 29 2012 Alex Szczuczko <aszczucz@redhat.com> - 0:1.0.0-1.4
- Add pom.patch to use jboss-javaee 5.0.2
- Change build dep junit44 to junit 4
- Update depmap

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.2-1.3.1.2.1
- rebuilt

* Tue Apr 20 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.0.2-1.3.1.2
- Rebuild
- Fix depmap entry for ejb3-persistence, dtdparser, and jbossts

* Tue Feb 16 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.0.2-1.3.1.1
- Rebuild with up to date jbossts

* Fri Feb 12 2010 Yong Yang <yyang@redhat.com> 0:1.0.2-1.3.1
- (B)R:  dtdparser, and add depmap for it
- Change depmap for jbossjta 

* Fri Dec 04 2009 Martha Benitez <mbenitez@redhat.com> 0:1.0.2-1.3
- Add javadoc and sources jar files to main package and repolib

* Tue Oct 13 2009 David Walluck <dwalluck@redhat.com> 0:1.0.2-1.2
- add repolib
- update license

* Tue Oct 13 2009 Fernando Nasser <fnasser@redhat.com> - 0:1.0.2-1.1
- Upgrade to 1.0.2 so that it builds with interceptors 1.0.5
- Use jboss-parent package

* Wed Sep 2 2009 Yong Yang <yyang@redhat.com> - 0:1.0.1-1.1
- Import from jpackage
- Change BR maven-shared-enforcer-rule-api to maven-enforcer-rule-api
- BR jbossws, jbossts
- Add jpp depmap for jboss-parent, jbossws, jsr173_api, jbossts

* Fri Aug 14 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.0.1-1
- first release
